#include <string.h>
#include "op5license.h"
#include "rsa.h"

char license_buffer[BUFSIZE];

static unsigned char *hexify(unsigned char *data, unsigned int len)
{
	int i, j = 0;
	unsigned char *ret;

	if (!(ret = malloc((len * 2) + 1)))
		return NULL;

	for (i = 0; i < len; i++) {
		const char hex[] = "0123456789abcdef";

		ret[j++] = hex[data[i] >> 4];
		ret[j++] = hex[data[i] & 0xf];
	}

	/* nul-terminate the buffer */
	ret[j] = 0;

	return ret;
}

unsigned char *calculate_digest(unsigned char *input)
{
	EVP_MD_CTX mdctx;
	const EVP_MD *md;
	unsigned char md_value[EVP_MAX_MD_SIZE];
	unsigned int md_len;

	md = EVP_sha1();
	EVP_MD_CTX_init(&mdctx);
	EVP_DigestInit_ex(&mdctx, md, NULL);
	EVP_DigestUpdate(&mdctx, input, strlen((char *)input));
	EVP_DigestFinal_ex(&mdctx, md_value, &md_len);
	EVP_MD_CTX_cleanup(&mdctx);

	return hexify(md_value, md_len);
}

char *license_to_string(ezxml_t license_node)
{
	ezxml_t cur_node = NULL;
	int buflen = 0;
	
	for (cur_node = license_node->child; cur_node; cur_node = cur_node->ordered)
	{
		if(!strcmp(cur_node->name, "item"))
		{
			char *name, *value;
			int len;

			name = (char *)ezxml_attr(cur_node, "name");
			value = (char *)ezxml_attr(cur_node, "value");

			if (BUFSIZE <= buflen + strlen(name) + strlen(value) + 4) {
				printf("License buffer exceeded. Aborting.\n");
				exit(2);
			}

			len = strlen(name);
			memcpy(&license_buffer[buflen], name, len);
			buflen += len;
			license_buffer[buflen++] = ':';
			license_buffer[buflen++] = ' ';

			len = strlen(value);
			memcpy(&license_buffer[buflen], value, len);
			buflen += len;
			license_buffer[buflen++] = ';';
		}
	}
	
	return license_buffer;
}
